%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%global srcname astring

Name:           ocaml-%{srcname}
Version:        0.8.5
Release:        %mkrel 5
Summary:        Alternative String module for OCaml
Group:          Development/OCaml

License:        ISC
URL:            https://erratique.ch/software/astring
Source0:        https://github.com/dbuenzli/%{srcname}/archive/v%{version}/%{srcname}-%{version}.tar.gz

# Adapt to changed behavior of Char.compare in OCaml 5.
# This affects x86_64, but not bytecode-only architectures.
Patch:          %{name}-ocaml5.patch

BuildRequires:  ocaml >= 4.05.0
BuildRequires:  ocaml-compiler-libs
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-rpm-macros
BuildRequires:  ocaml-topkg-devel

# Do not require ocaml-compiler-libs at runtime
%global __ocaml_requires_opts -i Asttypes -i Build_path_prefix_map -i Cmi_format -i Env -i Format_doc -i Ident -i Identifiable -i Load_path -i Location -i Longident -i Misc -i Oprint -i Outcometree -i Parsetree -i Path -i Primitive -i Shape -i Subst -i Toploop -i Type_immediacy -i Types -i Unit_info -i Warnings

%description
Astring exposes an alternative `String` module for OCaml.  This module
tries to balance minimality and expressiveness for basic, index-free,
string processing and provides types and functions for substrings,
string sets and string maps.

Remaining compatible with the OCaml `String` module is a non-goal.  The
`String` module exposed by Astring has exception safe functions,
removes deprecated and rarely used functions, alters some signatures
and names, adds a few missing functions and fully exploits OCaml's
newfound string immutability.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%autosetup -N -n astring-%{version}
%ifarch %{ocaml_native_compiler}
%autopatch -p1
%endif

%conf
# Topkg does watermark replacements only if run inside a git checkout.  Github
# tarballs do not come with a .git directory.  Therefore, we do the watermark
# replacement manually.
for fil in $(find . -type f); do
  sed -e 's,%%%%NAME%%%%,astring,' \
      -e 's,%%%%PKG_HOMEPAGE%%%%,%{url},' \
      -e 's,%%%%VERSION%%%%,v%{version},' \
      -e 's,%%%%VERSION_NUM%%%%,%{version},' \
      -i.orig $fil
  touch -r $fil.orig $fil
  rm $fil.orig
done

%build
# Build the library and the tests
ocaml pkg/pkg.ml build --tests true

%install
%ocaml_install

%check
#ocaml pkg/pkg.ml test

%files -f .ofiles
%doc CHANGES.md README.md
%license LICENSE.md

%files devel -f .ofiles-devel



%changelog
* Mon Jul 07 2025 umeabot <umeabot> 0.8.5-5.mga10
+ Revision: 2250710
- Mageia 10 Mass Rebuild

* Fri Apr 04 2025 pterjan <pterjan> 0.8.5-4.mga10
+ Revision: 2173490
- Rebuild for ocaml 5.3.0

* Thu May 19 2022 pterjan <pterjan> 0.8.5-3.mga9
+ Revision: 1859001
- Rebuild for OCaml 4.14

* Wed Oct 13 2021 tv <tv> 0.8.5-2.mga9
+ Revision: 1751061
- Rebuild for ocaml 4.13.1

* Fri Mar 05 2021 tv <tv> 0.8.5-1.mga9
+ Revision: 1699887
- 0.8.5

* Sun Jan 10 2021 pterjan <pterjan> 0.8.3-5.mga8
+ Revision: 1670428
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 0.8.3-4.mga8
+ Revision: 1551653
- Rebuild for ocaml 4.10.0 final

* Thu Feb 20 2020 umeabot <umeabot> 0.8.3-3.mga8
+ Revision: 1545753
- Mageia 8 Mass Rebuild

* Wed Jan 29 2020 tv <tv> 0.8.3-2.mga8
+ Revision: 1485153
- imported package ocaml-astring


* Sun Jan 19 2020 Richard W.M. Jones <rjones@redhat.com> - 0.8.3-2
- OCaml 4.10.0+beta1 rebuild.

* Wed Jan  8 2020 Jerry James <loganjerry@gmail.com> - 0.8.3-1
- Initial RPM
